clear;
g=2.1;
fourpiMs=10000;
Hext=1103.3;
dH=30;
sigma=0.7e5;
A=1.14e-6;
mu0=4*pi*10^-9;
e0=1/(36*pi)*10^-11;
f=0:1e7:3e10;
omegap=2.*pi.*f;
omega=omegap-j.*dH./2;
gamma=g.*0.8805e7;

H0=Hext;
e=-j.*sigma./omega;
M=fourpiMs./(4.*pi);
k0=sqrt(omega.^2.*e.*mu0);

a1=1;
a2=(2.*H0+fourpiMs)./(2.*A./M)-k0.^2;
a3=(H0.*(H0+fourpiMs)-(omega./gamma).^2)./(4.*A.^2./M.^2)-2.*(H0+fourpiMs)./(2.*A./M).*k0.^2;
a4=((omega./gamma).^2-(H0+fourpiMs).^2)./(4.*A.^2./M.^2).*k0.^2;


p=0;
r=0;
for counter=1:length(omega)
    p=[a1 a2(counter) a3(counter) a4(counter)];
    r(counter,1:3)=roots(p);
end

k2=-j.*omega.*sigma.*mu0;

dispersion(:,1)=omegap./gamma;
dispersion(:,2)=sqrt(r(:,1));
dispersion(:,3)=sqrt(r(:,2));
dispersion(:,4)=-sqrt(r(:,3));
dispersion(:,5)=sqrt(k2);

root1(:,1)=real(dispersion(:,2));
root1(:,2)=real(dispersion(:,1));
root1(:,3)=-imag(dispersion(:,2));
root1(:,4)=real(dispersion(:,1));

root2(:,1)=real(dispersion(:,3));
root2(:,2)=real(dispersion(:,1));
root2(:,3)=-imag(dispersion(:,3));
root2(:,4)=real(dispersion(:,1));

root3(:,1)=real(dispersion(:,4));
root3(:,2)=real(dispersion(:,1));
root3(:,3)=imag(dispersion(:,4));
root3(:,4)=real(dispersion(:,1));

root4(:,1)=real(dispersion(:,5));
root4(:,2)=real(dispersion(:,1));
root4(:,3)=imag(dispersion(:,5));
root4(:,4)=real(dispersion(:,1));

figure;
hold on;
plot(root1(:,1), root1(:,2), '-b', root1(:,3), root1(:,4), '--b');
plot(root2(:,1), root2(:,2), '-r', root2(:,3), root2(:,4), '--r');
plot(root3(:,1), root3(:,2), '-g', root3(:,3), root3(:,4), '--g');
plot(root4(:,1), root4(:,2), '-c', root4(:,3), root4(:,4), '--c');
hold off;

figure;
hold on;
plot(root1(:,1), root1(:,2), '-b', root1(:,3), root1(:,4), '--b');
plot(root2(:,1), root2(:,2), '-r', root2(:,3), root2(:,4), '--r');
plot(root3(:,1), root3(:,2), '-g', root3(:,3), root3(:,4), '--g');
plot(root4(:,1), root4(:,2), '-c', root4(:,3), root4(:,4), '--c');
axis([-14e4 10e4 0 1.6e4]);
hold off;
